// A nice trail effect
// matt sarnoff nov 12 04

#ifndef ALPHATRAIL_H
#define ALPHATRAIL_H

#include <allegro.h>

#define TAIL_MAX_LENGTH 60

extern int polyTempPoints[8];
void quadrilateral(BITMAP *bmp, int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4, int color);

// Interpolation functions
float lerp(float y0, float y1, float mu);
float cuberp(float y0, float y1, float y2, float y3, float mu);

struct atSeg
{
  int prev;
  int x;
  int y;
  float xang;
  float yang;
};

class alphatrail
{
  public:
    int count;
    atSeg seg[TAIL_MAX_LENGTH];
    int headIndex, tailUsed;
    int headThickness, tailThickness;
    int length, color;
    
    alphatrail();
    alphatrail(alphatrail &copyAlphaTrail); // copy constructor

    void reset();
    void set(int newHeadThickness, int newTailThickness, int newLength, int color);
    void addSegment(int newx, int newy, int angle);
    void draw();
};

#endif
