/* INCLUDE IN SATURN.H, & INCLUDE SATURN.H IN EVERYTHING */

enum {BOMB_DUMB,BOMB_HARPOON,BOMB_CLUSTER,BOMB_HE,BOMB_BUNKERBUSTER,
      BOMB_DOUBLE,BOMB_EMP,BOMB_PLASTIC,BOMB_LASER,BOMB_NAPALM,BOMB_NUKE,BOMB_TYPES};

#define BOMB_KINDS BOMB_TYPES

#define BOMB_IMAGEFILE_MAX_W 16
#define BOMB_IMAGEFILE_MAX_H 8
#define NUM_LIVEBOMBS 20
#define TERMINAL_VELOCITY 8.0

#define BOMB_LESSMASS_WINDTURB_AFFECT_SCALAR 2.0

#define CLUSTER_BOMB_TIMER 40
#define LASER_BOMB_LOCKON_TIMER 30
#define LASER_BOMB_SPEED 8.0
#define HARPOON_BOMB_SPEED 15.0

#define EMP_JAM_DELAY_BY_MAP_W 5
#define NUKE_HURT_BY_MAP_W 1

#define BOMB_GRAVITY (level.gravityScalar/3.0)

enum {KEEPALIVE,DETONATE,VANISH,FIRST_EXPLOSION,INSIDE_BUILDING};

void loadBombGraphics();
void unloadBombGraphics();

void explodeBulletSams(int bulletsamIndex);

class bomb_breed_typ // defined in bomb.cpp
  {
  public:
  BITMAP *BOMB;
  int cost;
  int myID; // useful for behavioral FSM
  int damage;
  int dropBombReloadTime;
  int shakeMin;
  int shakeRandAddTo;
  int capacityPerRun;
  float stallOverallSpeed;
  float noseDriftForce;

  bomb_breed_typ();
  void loadGraphics(int myType);
  void unloadGraphics();
  };

extern bomb_breed_typ bombBreed[BOMB_TYPES];

class bomb_typ // defined in bomb.cpp
  {
  public:
  float x,y;
  float xv,yv;
  float target_x,target_y,target_timer; // only for laser guided, & cluster
  int type;
  int facing;
  fix bombAngle,bombSpeed;
  float flippedFacingAngle;
  int detonateOrVanishFlag;

  bomb_typ();
  void reset();
  void launch(int new_x, int new_y, int init_xv,int init_yv,int new_ang,
                                                   int new_facing,int new_type);
  void moveBomb();
  void drawBomb();
  bomb_typ(bomb_typ &copyBomb);
  };

extern bomb_typ bomb[NUM_LIVEBOMBS];


