/* INCLUDE IN SATURN.H, & INCLUDE SATURN.H IN EVERYTHING */

enum {BULLET_BASIC, BULLET_ADV, SAM_BASIC, SAM_ADV,
      RESOURCE_MOMPOP,RESOURCE_PIRATES,RESOURCE_BIGGOV,RESOURCE_HOME,
      BULLETSAM_TYPES};

#define NUM_LIVEBULLETSAMS 270
#define BULLET_VELOCITY 10.5
#define SAM_VELOCITY 6.5

#define GETSET_BULLETSAM_PROPERTY(field,default) \
    bulletsamBreed[i].field=get_config_int(bulletsamNumName,#field, default); \
    set_config_int(bulletsamNumName,#field, bulletsamBreed[i].field);

#define GETSET_BULLETSAM_PROPERTY_F(field,default) \
    bulletsamBreed[i].field=get_config_float(bulletsamNumName,#field, default); \
    set_config_float(bulletsamNumName,#field, bulletsamBreed[i].field);

#define MATCH_INI_NAME_TO_DEF_BULLETSAM(word) \
   case word: strcpy(bulletsamNumName,#word); \
   break;

#define GETSET_MIN_RANDADD_SET_BULLETSAM(min,maxRandAddedTo,defMin,defMaxRand) \
    bulletsamBreed[i].min=get_config_int(bulletsamNumName,#min, defMin); \
    bulletsamBreed[i].maxRandAddedTo=get_config_int(bulletsamNumName,#maxRandAddedTo, defMaxRand); \
    set_config_int(bulletsamNumName,#min, bulletsamBreed[i].min); \
    set_config_int(bulletsamNumName,#maxRandAddedTo, bulletsamBreed[i].maxRandAddedTo);

#define GETSET_MIN_RANDADD_SET_F_BULLETSAM(min,maxRandAddedTo,defMin,defMaxRand) \
    bulletsamBreed[i].min=get_config_float(bulletsamNumName,#min, defMin); \
    bulletsamBreed[i].maxRandAddedTo=get_config_float(bulletsamNumName,#maxRandAddedTo, defMaxRand); \
    set_config_float(bulletsamNumName,#min, bulletsamBreed[i].min); \
    set_config_float(bulletsamNumName,#maxRandAddedTo, bulletsamBreed[i].maxRandAddedTo);

#define SET_TO_BULLETSAM_BREED_RANGE(val,min,maxRand) \
    if(bulletsamBreed[type].maxRand != 0) \
      val=bulletsamBreed[type].min+(rand()%bulletsamBreed[type].maxRand); \
    else \
      val=bulletsamBreed[type].min;

#define SET_TO_BULLETSAM_BREED_RANGE_F(val,min,maxRand) \
    if(bulletsamBreed[type].maxRand != 0) \
      val=bulletsamBreed[type].min+(((float)rand()/RAND_MAX)*bulletsamBreed[type].maxRand); \
    else \
      val=bulletsamBreed[type].min;

#define BULLETSAM_LESSMASS_WINDTURB_AFFECT_SCALAR 0.5

#define BULLETSAM_GRAVITY (BOMB_GRAVITY/3.0)

#define LAUNCH_EXPLOSION_PARTICLES_BULLETSAM(num,type) \
    for(int ii=0; ii<num; ii++) \
      if(g_liveParticles<NUM_LIVEPARTICLES-1) \
        particle[g_liveParticles].launch(bulletsam[bulletsamIndex].x, \
                                     bulletsam[bulletsamIndex].y,0,0, \
                                      rand()%256,255,1.0,type);

#define LAUNCH_FLAME_PARTICLES_BULLETSAM(num,type) \
    for(int ii=0; ii<num; ii++) \
      if(g_liveParticles<NUM_LIVEPARTICLES-1) \
        particle[g_liveParticles].launch(bulletsam[bulletsamIndex].x, \
                                  bulletsam[bulletsamIndex].y-32,0,0, \
        rand()%256,255,1.0,type);  

enum {BULLETSAM_VIS_NOBITMAP,BULLETSAM_VIS_BITMAP,BULLETSAM_VIS_ALPHA,
                   BULLETSAM_VIS_LASER,BULLETSAM_VIS_RAILGUN,BULLETSAM_VIS_NUM};


void loadBulletSamGraphicsAndData();
void unloadBulletSamGraphics();

void explodeBulletSams(int bulletsamIndex);

class bulletsam_breed_typ // defined in bulletsam.cpp
  {
  public:
  BITMAP *BULLETSAM;
  int myBulletSamType;
  int visualIndex;
  int color;
  int minLife;
  int maxRandAddedToMinLife;
  int minVel;
  int maxRandAddedToMinVel;
  int minMovementAngle;
  int maxRandAddedToMinMovementAngle;
  int minAlphaDelt;
  int maxRandAddedToMinAlphaDelt;
  int minReloadTime;
  int maxRandAddedToReloadTime;
  float minScaleDelt;
  float maxRandAddedToMinScaleDelt;
  float specificGravityMult;
  float weatherAffect;
  int trailLength;
  int trailWidthTop, trailWidthBot;

  bulletsam_breed_typ();

  void unloadGraphics();
  };

extern bulletsam_breed_typ bulletsamBreed[BULLETSAM_TYPES];

class bulletsam_typ // defined in bullet.cpp
  {
  public:
  float x,y;
  int startX, startY; // for the resource-delivery effects
  float xv,yv;
  float angDelta;
  float ang;
  float alphaDelta;
  float alpha;
  float scaleDelta;
  float scale;
  float speed;
  int life;
  int type;
  int detonateOrVanishFlag;
  alphatrail trail;

  bulletsam_typ();
  void reset();
  void launch(float new_x, float new_y, float new_alpha,int new_type);
  void moveBulletSam();
  void drawBulletSam();
  bulletsam_typ(bulletsam_typ &copyBulletSam);
  };

extern bulletsam_typ bulletsam[NUM_LIVEBULLETSAMS];


