/* INCLUDE IN SATURN.H, & INCLUDE SATURN.H IN EVERYTHING */

#define LOADLEVEL_NOERROR(lvlLoad) (lvlLoad==0)
#define LOADLEVEL_HASERROR(lvlLoad) (lvlLoad/*!=0*/)

#define RICH_FINISH 10000

#define LEVEL_TITLE_DISPLAY_CYCLES 370

#define BOMB_SPACING 3 // pixels apart in GUI

#define BUILDING_W 64
#define BUILDING_SPACING 8
#define BUILDING_H 128
#define BUILDING_W_SHIFT 6 // because 2<<6=64, we can do quick mult/divis this way
#define MAP_W 42
#define GRID_START_CORNER_X 44
#define GRID_START_CORNER_Y 1178
#define GRID_END_CORNER_X (GRID_START_CORNER_X+(MAP_W<<BUILDING_W_SHIFT))
#define GRID_END_CORNER_Y (GRID_START_CORNER_Y)
#define MIN_DISTANCE_FROM_TARGETCENTER_TO_SCORE 50.0

#define PIXEL2BUILDING_X(val)((val-GRID_START_CORNER_X)/(BUILDING_W+BUILDING_SPACING))
#define PIXELBUILDING_Y (level.i_platformDriftHeightCurrent- \
              (level.BUILDING[player.defendCorp()]      \
                                [level.building[i][PLYR_TARGETS]][0]->h))
#define BUILDING2PIXEL_X(val) (BUILDING2CENTERPIXEL_X(val)-(BUILDING_W>>1))
#define BUILDING2CENTERPIXEL_X(val) (GRID_START_CORNER_X+(BUILDING_W>>1)+val*(BUILDING_W+BUILDING_SPACING))

#define BUILDING_DAMAGE_FRAMES 1

#define UNREASONABLE_THREASHOLD 15.0 // for limiting wind, gravity, etc.

#define LEVEL_TITLE_MAX_LENGTH 30

// STATUS BAR defines, since that gets drawn by level.cpp
#define SBAR_INFO_RESERVES_X 313
#define SBAR_INFO_RESERVES_Y 131
#define SBAR_INFO_SPECIAL_X SBAR_INFO_RESERVES_X
#define SBAR_INFO_SPECIAL_Y 167
#define SBAR_PITCH_X 481
#define SBAR_PITCH_Y 134
#define SBAR_PITCH_X2 515
#define SBAR_PITCH_Y2 168
#define SBAR_PITCH_XM 492
#define SBAR_PITCH_YM 151
#define SBAR_THROTTLE_X 591
#define SBAR_THROTTLE_Y 132
#define SBAR_WINDSOCK_X 514
#define SBAR_WINDSOCK_Y 33
#define SBAR_TURB_X SBAR_WINDSOCK_X
#define SBAR_TURB_Y 68
#define SBAR_MONEY_X1 359
#define SBAR_MONEY_X2 662
#define SBAR_MONEY_Y 12

#define PITCH_TURB_EXAGG 5.0
#define TURB_WIND_EXAGG_WINSOCK 150.0

#define RESOURCE_CASH_BENEFIT 150 // cash per surviving reserve

#define DEFLECTION_TOWER_RANGE 140.0

#define NUKE_EXPLOSION_RANGE 240.0

#define PLYR_TARGETS player.activePlayer

#define LIMIT_WITHIN(val,max)         \
    if(val<-max)                      \
      val=-max;                       \
    else if(val>max)                  \
      val=max;

#define INCREASE_UPTO(n,u) {if(n<u) n=u;}

enum {BLDG_RESOURCE,BLDG_REPAIR,BLDG_DEFLECTION,BLDG_STDAA,BLDG_ADVAA,
               BLDG_STDSAM,BLDG_ADVSAM,BLDG_CRITICALTARGET,BLDG_TYPES};

enum {NO_WIN,P1_WIN,P2_WIN,DRAW_WIN};

#define BLDG_NONE BLDG_TYPES

class level_typ
  {
  public:
  int buildingHealth_MAX[BLDG_TYPES];
  int building[MAP_W][PLAYER_NUM];
  int buildingReload[MAP_W];
  int buildingHealth[MAP_W][PLAYER_NUM];
  int levelCount;
  BITMAP *BUILDING[NUM_OF_CORPORATIONS][BLDG_TYPES][BUILDING_DAMAGE_FRAMES];
  BITMAP *BACKGROUND, *PLATFORM, *STATUSBAR, *TOPBAR, *PITCHCROSS;
  BITMAP *THROTTLEBAR;
  int platformFalling;
  float platformFreefall_yv;
  int i_platformDriftHeightCurrent; // cached for checks with collisions
  float platformDriftHeightCenter,platformDriftHeightCurrent,platformDriftAngle;
  float platformDriftRapidity,platformDriftDistance;
  int playersMode;

  char levelTitle[LEVEL_TITLE_MAX_LENGTH];
  int displayTitleTime;

  float gravityScalar;

  int levelsUnlocked, shipsUnlocked;

  int currentLevel;
  int subLevel;
  int goodEvilRecord;

  level_typ();
  void getLevelCount();
  float fastDiamondDistance(float x,float y);
  void loadGraphics();
  void unloadGraphics();
  void resetToOpeningLevel(int startLevel);
  int loadBldg();
  void moveBuildings(); // let AA and SAMs fire, etc.
  int levelIsOver(); // return NO_WIN,P1_WIN,P2_WIN
  void drawBackgroundAndBuildings();
  void drawSBar();
  int underlyingBldg(float pixel_x,float pixel_y, int *xt, int *yt);
  };

extern level_typ level;

