/* INCLUDE IN SATURN.H, & INCLUDE SATURN.H IN EVERYTHING */

enum {PARTICLE_SOLID,PARTICLE_BITMAP,PARTICLE_SMOKE,PARTICLE_DEBRIS_CLOUD,
      PARTICLE_NAPALM,PARTICLE_FLAME,
      PARTICLE_EXPLOSION1,PARTICLE_EXPLOSION2,PARTICLE_EXPLOSION3,PARTICLE_EXPLOSION4,
      PARTICLE_EXPLOSION_SM1,
      PARTICLE_SPARK,PARTICLE_EMP_RING,PARTICLE_EMP_BOLT,PARTICLE_SHARD, 
      PARTICLE_DEBRIS1,PARTICLE_DEBRIS2,PARTICLE_DEBRIS3,PARTICLE_DEBRIS4,
      PARTICLE_DEBRIS_SM1,PARTICLE_DEBRIS_SM2,
      PARTICLE_BOMBLET,
      PARTICLE_NUKE_BLAST,PARTICLE_NUKE_BOMBLET,
      PARTICLE_TYPES,NUM_EXPLOSIONS=4,NUM_DEBRIS=6,NUM_DEBRIS_SM=2};

#define GETSET_PARTICLE_PROPERTY(field,default) \
    particleBreed[i].field=get_config_int(particleNumName,#field, default); \
    set_config_int(particleNumName,#field, particleBreed[i].field);

#define GETSET_PARTICLE_PROPERTY_F(field,default) \
    particleBreed[i].field=get_config_float(particleNumName,#field, default); \
    set_config_float(particleNumName,#field, particleBreed[i].field);

#define MATCH_INI_NAME_TO_DEF(word) \
   case word: strcpy(particleNumName,#word); \
   break;

#define GETSET_MIN_RANDADD_SET(min,maxRandAddedTo,defMin,defMaxRand) \
    particleBreed[i].min=get_config_int(particleNumName,#min, defMin); \
    particleBreed[i].maxRandAddedTo=get_config_int(particleNumName,#maxRandAddedTo, defMaxRand); \
    set_config_int(particleNumName,#min, particleBreed[i].min); \
    set_config_int(particleNumName,#maxRandAddedTo, particleBreed[i].maxRandAddedTo);

#define GETSET_MIN_RANDADD_SET_F(min,maxRandAddedTo,defMin,defMaxRand) \
    particleBreed[i].min=get_config_float(particleNumName,#min, defMin); \
    particleBreed[i].maxRandAddedTo=get_config_float(particleNumName,#maxRandAddedTo, defMaxRand); \
    set_config_float(particleNumName,#min, particleBreed[i].min); \
    set_config_float(particleNumName,#maxRandAddedTo, particleBreed[i].maxRandAddedTo);

#define SET_TO_PARTICLE_BREED_RANGE(val,min,maxRand) \
    if(particleBreed[type].maxRand != 0) \
      val=particleBreed[type].min+(rand()%particleBreed[type].maxRand); \
    else \
      val=particleBreed[type].min;

#define SET_TO_PARTICLE_BREED_RANGE_F(val,min,maxRand) \
    if(particleBreed[type].maxRand != 0) \
      val=particleBreed[type].min+(((float)rand()/RAND_MAX)*particleBreed[type].maxRand); \
    else \
      val=particleBreed[type].min;

#define LAUNCH_EXPLOSION_PARTICLES(num,type) \
    for(int ii=0; ii<num; ii++) \
      if(g_liveParticles<NUM_LIVEPARTICLES-1) \
        particle[g_liveParticles].launch(bomb[bombIndex].x, bomb[bombIndex].y,0,0, \
        rand()%256,255,1.0,type);

#define LAUNCH_EXPLOSION_PARTICLES_EX(num,xi,yi,sc,type) \
    for(int iii=0; iii<num; iii++) \
      if(g_liveParticles<NUM_LIVEPARTICLES-1) \
        particle[g_liveParticles].launch(xi, yi, 0, 0, \
          rand()%256,255,sc,type);

// Same as above, but offsets the y-coordinate by 32 pixels
// (half the height of the flame sprite)
#define LAUNCH_FLAME_PARTICLES(num,type) \
    for(int ii=0; ii<num; ii++) \
      if(g_liveParticles<NUM_LIVEPARTICLES-1) \
        particle[g_liveParticles].launch(bomb[bombIndex].x, bomb[bombIndex].y-32,0,0, \
        rand()%256,255,1.0,type);        

// handy macro for positive/negative random numbers
#define RAND_POS_NEG(x) rand()%(x*2)-x

#define RANDOM_EXPLOSION  PARTICLE_EXPLOSION1 + rand()%NUM_EXPLOSIONS
#define RANDOM_DEBRIS     PARTICLE_DEBRIS1 + rand()%NUM_DEBRIS
#define RANDOM_DEBRIS_SM  PARTICLE_DEBRIS_SM1 + rand()%NUM_DEBRIS_SM

#define PARTICLE_IMAGEFILE_MAX_W 16
#define PARTICLE_IMAGEFILE_MAX_H 8
#define NUM_LIVEPARTICLES 500
#define TERMINAL_VELOCITY 8.0

#define PARTICLE_LESSMASS_WINDTURB_AFFECT_SCALAR 2.5

#define PARTICLE_GRAVITY BOMB_GRAVITY

#define NUM_THIN_TRAIL_SEGMENTS      16

enum {PARTICLE_VIS_NOBITMAP,PARTICLE_VIS_EMP,PARTICLE_VIS_BITMAP,PARTICLE_VIS_ALPHA,PARTICLE_VIS_NUM};

void loadParticleGraphicsAndData();
void unloadParticleGraphics();

void explodeBunkerBusterParticles(int bombIndex);
void explodeParticles(int bombIndex);

struct thinTrailSegment
{
  float x, y;
  int intensity;
};

class thinTrail
{
  public:
    void init(float x, float y, int ijitter, float iweather, int idelay, int ialphadelt);
    void update(float x, float y);
    void draw(int px, int py, int color);
  private:
    thinTrailSegment seg[NUM_THIN_TRAIL_SEGMENTS];
    int numSegs;
    int jitter;
    float weatherAffect;
    int newSegDelay, alphaDelt;
    int counter;
};

class particle_breed_typ // defined in particle.cpp
  {
  public:
  BITMAP *PARTICLE;
  int myParticleType;
  int visualIndex;
  int animNumFrames;
  int animDelay;
  int maxRandAddedToAnimDelay;
  int animLoop;
  int color;
  int minLife;
  int maxRandAddedToMinLife;
  float minVel;
  float maxRandAddedToMinVel;
  int angleLock;
  int minRotVel;
  int maxRandAddedToMinRotVel;
  int minMovementAngle;
  int maxRandAddedToMinMovementAngle;
  int minAlphaDelt;
  int maxRandAddedToMinAlphaDelt;
  float minScaleDelt;
  float maxRandAddedToMinScaleDelt;
  float specificGravityMult;
  float bounceDampening;
  float weatherAffect;
  int canCollide;
  int trail;
  int trailJitter;

  particle_breed_typ();

  void unloadGraphics();
  };

extern particle_breed_typ particleBreed[PARTICLE_TYPES];

class particle_typ // defined in particle.cpp
  {
  public:
  float x,y;
  float xv,yv;
  float angDelta;
  float ang;
  float alphaDelta;
  float alpha;
  float scaleDelta;
  float scale;
  int life;
  int type;
  int animCounter;
  int animDelay;
  int animFrame;
  int animNumLoops;
  int detonateOrVanishFlag;
  thinTrail partTrail;

  particle_typ();
  void reset();
  void launch(float new_x, float new_y, float init_xv,float init_yv,
                                    float new_ang,float new_alpha,float new_scale,int new_type);
  void moveParticle();
  void drawParticle();
  particle_typ(particle_typ &copyParticle);
  };

extern particle_typ particle[NUM_LIVEPARTICLES];

void jitterCircle(int x, int y, float r, int jitter, int detail, int color);
void rippleCallback(BITMAP *bmp, int x, int y, int d);
void ripple(int x, int y, int rx, int ry, int w);


