#include "saturn.h"

plane_typ plane;

void loadPlaneGraphicsAndData()
  {
  for(int corp=0;corp<NUM_OF_CORPORATIONS;corp++)
    for(int type=0;type<PLANE_TYPES;type++)
      for(int econ=0;econ<PLANE_ECON;econ++)
        {
        planeBreed[corp][type][econ].loadGraphics(corp,type,econ);
        planeBreed[corp][type][econ].loadData();
        }
  }

void unloadPlaneGraphics()
  {
  for(int corp=0;corp<NUM_OF_CORPORATIONS;corp++)
    for(int type=0;type<PLANE_TYPES;type++)
      for(int econ=0;econ<PLANE_ECON;econ++)
        planeBreed[corp][type][econ].unloadGraphics();
  }

plane_breed_typ planeBreed[NUM_OF_CORPORATIONS][PLANE_TYPES][PLANE_ECON];

  plane_breed_typ::plane_breed_typ()
    {
    corp=type=econ=0;
    cost=300;
    maxDumbBombs=5;
    PLANE=NULL;
    }

  void plane_breed_typ::loadGraphics(int myCorp,int myType,int myEcon)
    {
    int height,width;
    int doneHoriz,doneVert;
    BITMAP *scrap;
    PALETTE palette;
    scrap = load_pcx("data//ships.pcx",palette);

    corp=myCorp;
    type=myType;
    econ=myEcon;

    width=PLANE_IMAGEFILE_MAX_W-1;
    height=PLANE_IMAGEFILE_MAX_H-1;
    doneHoriz=doneVert=0;
    do
      {
      if(!doneVert)
        {
        for(int wx=0;wx<width;wx++)
          {
          if(getpixel(scrap,type*PLANE_IMAGEFILE_MAX_W+wx,
            corp*PLANE_IMAGEFILE_MAX_H*PLANE_ECON+econ*PLANE_IMAGEFILE_MAX_H+height)
            !=g_transparency)
            {
            doneVert=1;
            break;
            }
          }
        if(!doneVert) height--;
        }

      if(!doneHoriz)
        {
        for(int wy=0;wy<height;wy++)
          {
          if(getpixel(scrap,type*PLANE_IMAGEFILE_MAX_W+width,
            corp*PLANE_IMAGEFILE_MAX_H*PLANE_ECON+econ*PLANE_IMAGEFILE_MAX_H+wy)
            !=g_transparency)
            {
            doneHoriz=1;
            break;
            }
          }
        if(!doneHoriz) width--;
        }
      } while((doneHoriz==0 || doneVert==0) && height>1 && width>1);

    PLANE=create_bitmap(width,height);
    blit(scrap,PLANE,type*PLANE_IMAGEFILE_MAX_W,
      corp*PLANE_IMAGEFILE_MAX_H*PLANE_ECON+econ*PLANE_IMAGEFILE_MAX_H,
      0,0,width,height);

    destroy_bitmap(scrap);
    }

  void plane_breed_typ::loadData()
    {
    char shipdataName[20];
    char numScrap[5];

    set_config_file("data//shipstat.dat");

    switch(corp)
      {
      case CORP_MOMPOP: strcpy(shipdataName,"P"); break;
      case CORP_PIRATES: strcpy(shipdataName,"S"); break;
      case CORP_BIGGOV: strcpy(shipdataName,"J"); break;
      case CORP_HOME: strcpy(shipdataName,"H"); break;
      case CORP_BUG: strcpy(shipdataName,"I"); break;
      }
    switch(type)
      {
      case PLANE_TYPES_RECON: strcat(shipdataName,"r"); break;
      case PLANE_TYPES_ATTACK: strcat(shipdataName,"a"); break;
      case PLANE_TYPES_CARPET: strcat(shipdataName,"c"); break;
      case PLANE_TYPES_STEALTH: strcat(shipdataName,"s"); break;
      }
    switch(econ)
      {
      case PLANE_ECON_CHEAP: strcat(shipdataName,"1"); break;
      case PLANE_ECON_MID: strcat(shipdataName,"2"); break;
      case PLANE_ECON_EXPENSIVE: strcat(shipdataName,"3"); break;
      }

    GETSET_SHIP_NAME_PROPERTY(shipTitle,"Untitled");

    switch(corp)
      {
      case CORP_MOMPOP:
        strcpy(shipdataName,"MompopCo");
        break;
      case CORP_PIRATES:
        strcpy(shipdataName,"PirateCo");
        break;
      case CORP_BIGGOV:
        strcpy(shipdataName,"JunoCo");
        break;
      case CORP_HOME:
        strcpy(shipdataName,"HomeCo");
        break;
      case CORP_BUG:
        strcpy(shipdataName,"Insect");
        break;
      }

    int armorPerc,speedPerc,capacityPerc,discountPerc;

    GETSET_SHIP_CORP_PROPERTY(armorPerc,2);
    GETSET_SHIP_CORP_PROPERTY(speedPerc,2);
    GETSET_SHIP_CORP_PROPERTY(capacityPerc,2);
    GETSET_SHIP_CORP_PROPERTY(discountPerc,2);

    switch(type)
      {
      case PLANE_TYPES_RECON:
        strcpy(shipdataName,"Reconn");
        break;
      case PLANE_TYPES_ATTACK:
        strcpy(shipdataName,"Attack");
        break;
      case PLANE_TYPES_CARPET:
        strcpy(shipdataName,"Carpet");
        break;
      case PLANE_TYPES_STEALTH:
        strcpy(shipdataName,"Stealt");
        break;
      }
    switch(econ)
      {
      case PLANE_ECON_CHEAP:
        strcat(shipdataName,"Cheap");
        break;
      case PLANE_ECON_MID:
        strcat(shipdataName,"Mediu");
        break;
      case PLANE_ECON_EXPENSIVE:
        strcat(shipdataName,"Expen");
        break;
      }

    GETSET_SHIP_PROPERTY_INT(cost,300);
    GETSET_SHIP_PROPERTY(minSpeed,1.4);
    GETSET_SHIP_PROPERTY(maxSpeed,4.6);
    GETSET_SHIP_PROPERTY_INT(maxDumbBombs,5);
    GETSET_SHIP_PROPERTY(accelPower,0.04);
    GETSET_SHIP_PROPERTY(decelPower,0.03);
    GETSET_SHIP_PROPERTY(throttleLoss,0.999);
    GETSET_SHIP_PROPERTY(throttleLossWhenHit,0.80);
    GETSET_SHIP_PROPERTY_INT(healthMax,6);
    GETSET_SHIP_PROPERTY(upForce,0.3);
    GETSET_SHIP_PROPERTY(noseDriftForce,0.1);
    GETSET_SHIP_PROPERTY(stallOverallSpeed,2.4);

    // modify for this corp ...
    cost=cost+((cost*(2-discountPerc))>>2);
    healthMax=healthMax+((healthMax*(armorPerc-2))>>2);
    maxDumbBombs=maxDumbBombs+((maxDumbBombs*(capacityPerc-2))>>2);
    maxSpeed=maxSpeed+((maxSpeed*(speedPerc-2.0))/4.0);

    set_config_file("settings.ini");
    }

  void plane_breed_typ::unloadGraphics()
    {
    destroy_bitmap(PLANE);
    }

/* The actual class prototype is defined inside init.h */
  plane_typ::plane_typ()
    {
    facing=FACING_RIGHT;
    x=150;
    y=150;
    xv=1.0;
    yv=1.0;
    planeAngle=0;
    flippedFacingAngle=1.0;
    planeSpeed=1.0;
    speedAsPerc=1.0;
    dumbBombs=5;
    specialBombs=5;
    type=econ=0;
    health=5;
    afterDeathTimer=0;
    trail.set(6, 0, TAIL_MAX_LENGTH, makecol(0, 128, 255));
    }

  void plane_typ::reset()
    {
    planeSpeed=planeBreed[player.battleCorp()][type][econ].minSpeed;
    health=planeBreed[player.battleCorp()][type][econ].healthMax;
    planeAngle=0.0;
    dumbBombs=(int)(bombBreed[BOMB_DUMB].capacityPerRun
        * planeBreed[player.battleCorp()][type][econ].maxDumbBombs);
    specialBombs=(int)(planeBreed[player.battleCorp()][type][econ].maxDumbBombs/
        bombBreed[player.specialBombArmed].capacityPerRun);
    switch(type)
      {
      case PLANE_TYPES_RECON:
        trail.set(3, 1, 60, makecol(0, 128, 255));
        break;
      case PLANE_TYPES_ATTACK:
        trail.set(6, 2, 35, makecol(64, 255, 64));
        break;
      case PLANE_TYPES_CARPET:
        trail.set(9, 3, 50, makecol(255, 128, 0));
        break;
      case PLANE_TYPES_STEALTH:
        trail.set(2, 0, 10, makecol(60, 60, 60));
        break;
      }

    if(level.playersMode==P1)
      {
      placePlaneAt(START_ALTITUDE,-facing);
      }
    else
      {
      if(player.activePlayer==P1)
        placePlaneAt(START_ALTITUDE,FACING_RIGHT);
      else
        placePlaneAt(START_ALTITUDE,FACING_LEFT);
      }
    }

  void plane_typ::placePlaneAt(int new_y, int new_facing)
    {
    /* subtract half of the PLANE bitmap's height
       and width so that it will be placed with
       the center of the bitmap over the new_x
       and new_y sent */
    facing=new_facing;
    if(facing==FACING_LEFT)
      x=(float)PLANE_BOUNDARY_RIGHT;
    else
      x=(float)0;
    y=(float)new_y;
    }

  void plane_typ::adjustPerControls(int playerInput)
    {
    if(playerInput==ACTION_NONE)
      return;

    if(player.ownsPlane(econ*PLANE_TYPES+type)==0)
      return; // plane has been destroyed, waiting for respawn

    if((facing==FACING_LEFT &&
       x<PLANE_BOUNDARY_LEFT-(planeBreed[player.battleCorp()][type][econ].PLANE->w)) ||
       (facing==FACING_RIGHT &&
       x>PLANE_BOUNDARY_RIGHT+(planeBreed[player.battleCorp()][type][econ].PLANE->w)))
      return;

    if(health>0)
      {
      if(getBit(playerInput,ACTION_SPEEDUP))
        {
        if(planeSpeed<planeBreed[player.battleCorp()][type][econ].maxSpeed)
          planeSpeed+=planeBreed[player.battleCorp()][type][econ].accelPower;
        if(planeSpeed>planeBreed[player.battleCorp()][type][econ].maxSpeed)
          planeSpeed=planeBreed[player.battleCorp()][type][econ].maxSpeed;
        else
          sound.queueSound(SFXengUp,255,x);
        }
      else if(getBit(playerInput,ACTION_SPEEDDOWN))
        {
        if(planeSpeed>planeBreed[player.battleCorp()][type][econ].minSpeed)
          planeSpeed-=planeBreed[player.battleCorp()][type][econ].decelPower;
        if(planeSpeed<planeBreed[player.battleCorp()][type][econ].minSpeed)
          planeSpeed=planeBreed[player.battleCorp()][type][econ].minSpeed;
        else
          sound.queueSound(SFXengDown,255,x);
        }
      }

    if(getBit(playerInput,ACTION_PITCHDOWN))
      {
      planeAngle++;
      }
    else if(getBit(playerInput,ACTION_PITCHUP))
      {
      planeAngle--;
      }

    if(getBit(playerInput,ACTION_DROPDUMB))
      {
      if(dumbBombs>0)
        {
        dumbBombs--;
        if(g_liveBombs<NUM_LIVEBOMBS-1)
          {
          bomb[g_liveBombs].launch(x, y, xv,yv,planeAngle,facing,BOMB_DUMB);
          sound.queueSound(SFXrocketOut,255,x);
          }
        }
      else
        sound.queueSound(SFXempty,255,x);
      }
    if(getBit(playerInput,ACTION_DROPSPECIAL))
      {
      if(specialBombs>0)
        {
        specialBombs--;
        if(g_liveBombs<NUM_LIVEBOMBS-1)
          {
          bomb[g_liveBombs].launch(x, y, xv,yv,planeAngle,facing,
                                                       player.specialBombArmed);
          sound.queueSound(SFXrattleOut,255,x);
          }
        }
      else
        sound.queueSound(SFXempty,255,x);
      }

    }

  void plane_typ::movePlane()
    {
    float planeSpeedExtra;
    float topNormalVectorAngle;

    if(player.ownsPlane(econ*PLANE_TYPES+type)==0)
      {
      if(afterDeathTimer<=0)
        gamemenu.runLoadoutMenu(0);
      return; // player lost their plane.  :-(
      }

    if(plane.facing==FACING_RIGHT)
      {
      flippedFacingAngle=planeAngle;
      topNormalVectorAngle=flippedFacingAngle-64.0;
      }
    else
      {
      flippedFacingAngle=255.0-(planeAngle-128.0);
      topNormalVectorAngle=flippedFacingAngle+64.0;
      }

      // engine thrust
    xv=planeSpeed*cos(flippedFacingAngle);
    yv=planeSpeed*sin(flippedFacingAngle);
    planeSpeedExtra=PITCH_SPEED_AERODYN_EFFECT*sin(flippedFacingAngle);

    planeSpeed*=planeBreed[player.battleCorp()][type][econ].throttleLoss;

    // facing down = faster fall
    xv*=((planeSpeedExtra+PITCH_SPEED_AERODYN_EFFECT*1.2)+3.0)/4.0;
    yv*=((planeSpeedExtra+PITCH_SPEED_AERODYN_EFFECT*1.2)+3.0)/4.0;

    // upforce from wings
    xv=xv+planeSpeed*planeBreed[player.battleCorp()][type][econ].upForce*cos(topNormalVectorAngle);
    yv=yv+planeSpeed*planeBreed[player.battleCorp()][type][econ].upForce*sin(topNormalVectorAngle);

    // apply gravity
    yv+=level.gravityScalar;

    // nose drift & stalling.  Too slow: dip; Too far: nose rises
    planeAngle+=(planeBreed[player.battleCorp()][type][econ].stallOverallSpeed-mag(xv,yv))*
                                  planeBreed[player.battleCorp()][type][econ].noseDriftForce;

    // prevent a player from flying inverted
    float angDistFromForceNoseFall=(planeAngle<0 ? -planeAngle : planeAngle);
    angDistFromForceNoseFall*=angDistFromForceNoseFall;
    planeAngle-=3.0*(angDistFromForceNoseFall/(128.0*128.0));

    speedAsPerc=(planeSpeed-planeBreed[player.battleCorp()][type][econ].minSpeed)/
      (planeBreed[player.battleCorp()][type][econ].maxSpeed-
        planeBreed[player.battleCorp()][type][econ].minSpeed);

    // affected most by turbulance when horizontal.  Faster=less stable nose
    planeAngle+=weather.turbNow*sin(flippedFacingAngle)*speedAsPerc;
    // affected most by wind when vertical.  Faster=less stable nose
    planeAngle+=weather.windNow*cos(flippedFacingAngle)*speedAsPerc;
     // going slower means wind has more effect on your position
    xv=xv+weather.windNow*cos(flippedFacingAngle)*(1.0-speedAsPerc);

    while(planeAngle<-128.0)
      planeAngle+=256.0;
    while(planeAngle>128.0)
      planeAngle-=256.0;

    int onScreen=1;

    if(facing==FACING_LEFT) // if moving left
      {
      if(x<PLANE_BOUNDARY_LEFT-(planeBreed[player.battleCorp()][type][econ].PLANE->w)) // and offscreen left
        {
        onScreen=0;
        if(g_liveBombs==0)
          {
          sound.queueSound(SFXengineChug,255,x);
          gamemenu.runLoadoutMenu(0);
          }
        else
          {
          int insanityStop=0;
          while(g_liveBombs>0 && insanityStop++<100) // 100 frame max.
            {
            level.moveBuildings(); // let AA and SAMs attack, etc.

            for(int i=0;i<g_liveBombs;i++)
              {
              bomb[i].moveBomb();
              switch(bomb[i].detonateOrVanishFlag)
                {
                case KEEPALIVE: break;
                case FIRST_EXPLOSION:
                  bomb[i].detonateOrVanishFlag = INSIDE_BUILDING;
                  break;
                case DETONATE:
                  explodeParticles(i); // in particle.cpp
                  // fall through to vanish
                case VANISH:
                  bomb[i--]=bomb[--g_liveBombs];
                  break;
                }
              }
            }
          sound.queueSound(SFXengineChug,255,x);
          gamemenu.runLoadoutMenu(0);
          }
        }
      }
    else // if moving right
      {
      if(x>PLANE_BOUNDARY_RIGHT+(planeBreed[player.battleCorp()][type][econ].PLANE->w)) // and offscreen right
        {
        onScreen=0;
        if(g_liveBombs==0)
          {
          sound.queueSound(SFXengineChug,255,x);
          gamemenu.runLoadoutMenu(0);
          }
        else
          {
          int insanityStop=0;
          while(g_liveBombs>0 && insanityStop++<100) // 100 frame max.
            {
            level.moveBuildings(); // let AA and SAMs attack, etc.

            for(int i=0;i<g_liveBombs;i++)
              {
              bomb[i].moveBomb();
              switch(bomb[i].detonateOrVanishFlag)
                {
                case KEEPALIVE: break;
                case FIRST_EXPLOSION:
                  bomb[i].detonateOrVanishFlag = INSIDE_BUILDING;
                  break;
                case DETONATE:
                  explodeParticles(i); // in particle.cpp
                  // fall through to vanish
                case VANISH:
                  bomb[i--]=bomb[--g_liveBombs];
                  break;
                }
              }
            }
          sound.queueSound(SFXengineChug,255,x);
          gamemenu.runLoadoutMenu(0);
          }
        }
      }

    if(onScreen)
      {
      x+=xv;
      y+=yv;
      }

    if(y<0)
      {
      planeSpeed*=0.8; // cut engine power
      }
    if(y>level.i_platformDriftHeightCurrent || y>GRID_START_CORNER_Y+500.0) // run into platform
      {
      sound.queueSound(SFXcrash,255,x);
      rectfill(DB,0,0,SCREEN_W,SCREEN_H,g_colorWhite);
      vsync();
      DB2SCREEN // white out screen briefly, and make time skip a beat
      rest(100);
      afterDeathTimer+=AFTER_DEATH_WAIT_TIME;
      player.takePlane(econ*PLANE_TYPES+type);
      LAUNCH_EXPLOSION_PARTICLES_EX(8, x, y, 1.0, RANDOM_DEBRIS);
      LAUNCH_EXPLOSION_PARTICLES_EX(20, x, y, 1.0, PARTICLE_SPARK);
      LAUNCH_EXPLOSION_PARTICLES_EX(3, x, y, 1.0, PARTICLE_SMOKE);
      LAUNCH_EXPLOSION_PARTICLES_EX(2, x, y, 1.0, RANDOM_EXPLOSION);
      return; // exit function
      }

    if(health<=0)
      {
      yv+=2.0*level.gravityScalar;
      y+=yv; // sink like a rock
      planeSpeed=0.0; // uh oh
      if(rand()%10==1)
        {
        if(g_liveParticles<NUM_LIVEPARTICLES-1)
          particle[g_liveParticles].launch(x, y,0,0,
          rand()%256,255,1.0,PARTICLE_SMOKE);
        }
      }

    for(int i=0;i<MAP_W;i++)
      {
      if(level.building[i][PLYR_TARGETS]!=BLDG_NONE)
        {
        if(y>level.i_platformDriftHeightCurrent-
                     (level.BUILDING[player.defendCorp()][level.building[i][PLYR_TARGETS]][0]->h))
          {
          if(x>GRID_START_CORNER_X+(BUILDING_W>>1)+i*(BUILDING_W+BUILDING_SPACING)
                   -(level.BUILDING[player.defendCorp()][level.building[i][PLYR_TARGETS]][0]->w>>1) &&
              x<GRID_START_CORNER_X+(BUILDING_W>>1)+i*(BUILDING_W+BUILDING_SPACING)
                   +(level.BUILDING[player.defendCorp()][level.building[i][PLYR_TARGETS]][0]->w>>1) )
            {
            sound.queueSound(SFXcrash,255,x);
            rectfill(DB,0,0,SCREEN_W,SCREEN_H,g_colorWhite);
            vsync();
            DB2SCREEN // white out screen briefly, and make time skip a beat
            rest(100);
            if(level.building[i][PLYR_TARGETS]!=BLDG_CRITICALTARGET)
              level.building[i][PLYR_TARGETS]=BLDG_NONE;
            sound.queueSound(SFXcrash,255,x);
            afterDeathTimer+=AFTER_DEATH_WAIT_TIME;
            player.takePlane(econ*PLANE_TYPES+type);
            LAUNCH_EXPLOSION_PARTICLES_EX(8, x, y, 1.0, RANDOM_DEBRIS);
            LAUNCH_EXPLOSION_PARTICLES_EX(20, x, y, 1.0, PARTICLE_SPARK);
            LAUNCH_EXPLOSION_PARTICLES_EX(3, x, y, 1.0, PARTICLE_SMOKE);
            LAUNCH_EXPLOSION_PARTICLES_EX(2, x, y, 1.0, RANDOM_EXPLOSION)
            break; // only hit 1 building
            }
          }
        }
      }
    trail.addSegment(
      ((int)x)-facing*cos(planeAngle)*(planeBreed[player.battleCorp()][type][econ].PLANE->w>>1),
      ((int)y)-sin(planeAngle)*(planeBreed[player.battleCorp()][type][econ].PLANE->w>>1),
      planeAngle*facing-64);
    }

  void plane_typ::drawPlane()
    {
    int xi=((int)x)-(planeBreed[player.battleCorp()][type][econ].PLANE->w>>1)-viewport.x;
    int yi=((int)y)-(planeBreed[player.battleCorp()][type][econ].PLANE->h>>1)-viewport.y;

    if(player.ownsPlane(econ*PLANE_TYPES+type)==0)
      {
      afterDeathTimer--;
      return; // they already died and lost their plane
      }

    trail.draw();

    if(facing==FACING_RIGHT)
      rotate_sprite_v_flip(DB,planeBreed[player.battleCorp()][type][econ].PLANE,xi,yi,ftofix(planeAngle+128.0));
    else
      rotate_sprite(DB,planeBreed[player.battleCorp()][type][econ].PLANE,xi,yi,ftofix(255.0-planeAngle));

    if(player.specialBombArmed==BOMB_LASER)
      {
      circlefill(DB,xi,level.i_platformDriftHeightCurrent-viewport.y,2,makecol(255,0,0));
      }
    }


