/* INCLUDE IN SATURN.H, & INCLUDE SATURN.H IN EVERYTHING */

enum {PLANE_TYPES_RECON,PLANE_TYPES_ATTACK,PLANE_TYPES_CARPET,
                                               PLANE_TYPES_STEALTH,PLANE_TYPES};
enum {PLANE_ECON_CHEAP,PLANE_ECON_MID,PLANE_ECON_EXPENSIVE,PLANE_ECON};
#define PLANE_KINDS (PLANE_TYPES*PLANE_ECON)

#define PLANE_IMAGEFILE_MAX_W 93
#define PLANE_IMAGEFILE_MAX_H 31

#define FACING_LEFT -1
#define FACING_RIGHT 1

#define PLANE_BOUNDARY_LEFT 0
#define PLANE_BOUNDARY_RIGHT viewport.boundaryRight
#define PLANE_BOUNDARY_TOP 0
#define PLANE_BOUNDARY_BOTTOM viewport.boundaryBottom

#define PITCH_SPEED_AERODYN_EFFECT 1.2

#define START_ALTITUDE 720

#define AFTER_DEATH_WAIT_TIME 200

#define GETSET_SHIP_NAME_PROPERTY(field,default) \
    strcpy(field,get_config_string(shipdataName,#field, default)); \
    set_config_string(shipdataName,#field, field);

#define GETSET_SHIP_CORP_PROPERTY(field,default) \
    field=get_config_int(shipdataName,#field, default); \
    set_config_int(shipdataName,#field, field);

#define GETSET_SHIP_PROPERTY(field,default) \
    field=get_config_float(shipdataName,#field, default); \
    set_config_float(shipdataName,#field, field);
#define GETSET_SHIP_PROPERTY_INT(field,default) \
    field=get_config_int(shipdataName,#field, default); \
    set_config_int(shipdataName,#field, field);

#define MAX_SHIPNAME_LENGTH 20

void loadPlaneGraphicsAndData();
void unloadPlaneGraphics();

class plane_breed_typ // defined in bomb.cpp
  {
  public:
  BITMAP *PLANE;
  char shipTitle[MAX_SHIPNAME_LENGTH];
  int corp,type,econ; // useful for behavioral FSM
  int healthMax;
  float upForce,noseDriftForce,stallOverallSpeed;
  float minSpeed,maxSpeed;
  int maxDumbBombs;
  float accelPower,decelPower;
  float throttleLoss, throttleLossWhenHit;
  int cost;

  plane_breed_typ();
  void loadGraphics(int myCorp,int myType,int myEcon);
  void loadData();
  void unloadGraphics();
  };

extern plane_breed_typ planeBreed[NUM_OF_CORPORATIONS][PLANE_TYPES][PLANE_ECON];

class plane_typ // defined in plane.cpp
  {
  public:
  int facing;
  float x,y;
  float xv,yv;
  fix planeAngle;
  float flippedFacingAngle;
  float planeSpeed, speedAsPerc;
  int dumbBombs,specialBombs;
  int type,econ;
  int health;
  int afterDeathTimer;
  alphatrail trail;

  plane_typ();
  void reset();
  void placePlaneAt(int new_y,int new_facing);
  void adjustPerControls(int playerInput);
  void movePlane();
  void drawPlane();
  };

extern plane_typ plane;

