/* INCLUDE IN SATURN.H, & INCLUDE SATURN.H IN EVERYTHING */

#define JOY_L (num_joysticks && joy[0].stick[0].axis[0].d1)
#define JOY_R (num_joysticks && joy[0].stick[0].axis[0].d2)
#define JOY_U (num_joysticks && joy[0].stick[0].axis[1].d1)
#define JOY_D (num_joysticks && joy[0].stick[0].axis[1].d2)
#define JOY_B(num) (num_joysticks && joy[0].button[num].b)

#define BALL_LAUNCH_ANGLE_MOUSE_INC 0.05
#define BALL_LAUNCH_POWER_MOUSE_INC ((BALL_MAX_SPEED)/250.0)
#define BALL_LAUNCH_ANGLE_KBOARD_INC 3.7
#define BALL_LAUNCH_POWER_KBOARD_INC ((BALL_MAX_SPEED)/25.0)

#define ANNIHILATION_MODE -2

#define STATUS_BAR_H 64

// flags used with keyboardHeld
enum {NO_KEY_PRESS,KEY_RELEASE,KEY_HELD};

#define onBit(val,bit) (val=val|(1<<bit))
#define getBit(val,bit) ((val>>bit)&1) // Powers of 2 so we can BOOLEAN together

#define MP_MAP_NUM 10
#define MP_ROUND_MAX 15 // AFTER 15, INFINITE
#define MP_FUNDS_MAX 5000
#define SINGLE_PLAYER_START_MONEY 4000
#define SINGLE_PLAYER_MONEY_PER_ROUND (225*(level.currentLevel*3+level.subLevel))
#define STANDING_BUILDING_FINE 1 // for worth after limited matches.  Per hp.

// used as returns from takeinput().
enum {ACTION_NONE,ACTION_SPEEDUP,ACTION_SPEEDDOWN,
                  ACTION_PITCHUP,ACTION_PITCHDOWN,
                  ACTION_DROPDUMB,ACTION_DROPSPECIAL,ACTION_NUM};

enum {P1,P2,PLAYER_NUM};

class own_typ
  {
  public:
  int planeIndex;
  int bombIndex;
  int plane[PLANE_KINDS];
  int bomb[BOMB_KINDS];
  int cash;
  own_typ();
  void reset();
  int worth(int myID);
  };

class player_typ
  {
  public:
  int keyboardHeld;
  int actionWaiting;
  int specialBombArmed;
  int bombReloadTime;
  int activePlayer;
  own_typ owns[PLAYER_NUM];
  int corp[PLAYER_NUM];
  int roundsLeft;
  int mp_map,mp_rounds,mp_funds;

  player_typ();

  void resetRounds();

  int battleCorp();
  int defendCorp();
  void setDefendCorp(int newCorp);
  void switchPlayers();
  int activePlaneIndex();
  int activeBombIndex();
  void findActivePlaneIndex();
  void findActiveBombIndex();
  void setActivePlaneIndex(int index);
  void setActiveBombIndex(int index);
  int ownsPlane(int index);
  void addPlane(int index);
  void takePlane(int index);
  int ownsBomb(int index);
  void addBomb(int index);
  void takeBomb(int index);
  int afford(int cost);
  void deduct(int cost);

  int takeInput();
  };

extern player_typ player;

