/*
"Saturn Storm"
Version 1.00 Public Release

Digital ground broken on Oct. 18 at 2:40 PM.

Completed the night of Nov. 20, following 5 days with a total of
11 hours of sleep.

Build #5

SEE README.TXT FOR MORE INFORMATION
*/

#include "saturn.h"

int inputGameFrame()
  {
  poll_joystick();

  if(key[KEY_ESC] || JOY_B(3))
    {
    while(key[KEY_ESC] || JOY_B(3))
      poll_joystick(); /* wait for the player to stop leaning on the key,
           otherwise they'll quit the opening title screen, too */
    menu.levelFocus=level.currentLevel-1; // stay in same spot on menu
    return OFF;
    }
  /* It just means, "quit the program."  We may find other
    useful return values here to do things like return to the
    main menu, pause the game, or do other interactions to the
    main game loop in main()
    */

  plane.adjustPerControls(player.takeInput()); // keyboard & joypad input

  return ON; /* continue playing */
  }

void moveGameFrame()
  {
  if(gamemenu.abortHack)
    return;

  weather.moveWeather();

  level.moveBuildings(); // let AA and SAMs attack, etc.

  for(int i=0;i<g_liveBombs;i++)
    {
    bomb[i].moveBomb();
    switch(bomb[i].detonateOrVanishFlag)
      {
      case KEEPALIVE: break;
      case FIRST_EXPLOSION:
        explodeBunkerBusterParticles(i); 
        bomb[i].detonateOrVanishFlag = INSIDE_BUILDING;
        break;
      case DETONATE:
        explodeParticles(i); // in particle.cpp
        viewport.shakeScreen(bombBreed[bomb[i].type].shakeMin+
                             (rand()%(bombBreed[bomb[i].type].shakeRandAddTo)));
        // fall through to vanish
      case VANISH:
        bomb[i--]=bomb[--g_liveBombs];
        break;
      }
    }

  for(int i=0;i<g_liveParticles;i++)
    {
    particle[i].moveParticle();
    switch(particle[i].detonateOrVanishFlag)
      {
      case KEEPALIVE: break;
      case DETONATE:
        LAUNCH_EXPLOSION_PARTICLES_EX(2, particle[i].x, particle[i].y, 1.0, PARTICLE_SPARK);
        if(g_liveParticles<NUM_LIVEPARTICLES-1)
          particle[g_liveParticles].launch(particle[i].x, particle[i].y,0,0,
                                     rand()%256,255,1.0,PARTICLE_EXPLOSION_SM1);
        sound.queueSound(SFXcrash,255, particle[i].x);
        // fall through to vanish
      case VANISH:
        particle[i--]=particle[--g_liveParticles];
        break;
      }
    }

  for(int i=0;i<g_liveBulletSams;i++)
    {
    bulletsam[i].moveBulletSam();
    switch(bulletsam[i].detonateOrVanishFlag)
      {
      case KEEPALIVE: break;
      case DETONATE:
        // fall through to vanish
       explodeBulletSams(i); // in particle.cpp
      case VANISH:
        bulletsam[i--]=bulletsam[--g_liveBulletSams];
        break;
      }
    }

  plane.movePlane();

  viewport.moveViewport();
  }

void drawGameFrame(int showOnScreen)
  {
  /* draw everything here.  Bear in mind that
     whatever is drawn last will be drawn "on top"
     of those things that were drawn before it.
     */
  if(gamemenu.abortHack)
    return;

  level.drawBackgroundAndBuildings();

  for(int i=0;i<g_liveBombs;i++)
    bomb[i].drawBomb();

  plane.drawPlane();

  for(int i=0;i<g_liveParticles;i++)
    particle[i].drawParticle();

  for(int i=0;i<g_liveBulletSams;i++)
    bulletsam[i].drawBulletSam();

  weather.drawWeather();
  
  level.drawSBar();

  if(!showOnScreen)
    return;

  viewport.drawViewport();

  if(key[KEY_P] || JOY_B(4) || JOY_B(5) || JOY_B(6) || JOY_B(7))
    { // paused, sort of roughly hacked in ;-)
    while(key[KEY_P] || JOY_B(4) || JOY_B(5) || JOY_B(6) || JOY_B(7))
      poll_joystick();

    menu.pauseScreen();

    while(key[KEY_P] || JOY_B(4) || JOY_B(5) || JOY_B(6) || JOY_B(7))
      poll_joystick();
    }
  rest(g_msDelayPerFrame);
  }

////////////////////////////////////////////////////////////////////
int main(int argc, char *argv[])////////////////////////////////////
  {
  int programon=1;
  PALETTE palette;
  BITMAP *bgImage, *FADECOPY;

  g_inGame=1; // declared in init.cpp

  /* Open/CloseAllegro are my own, and are defined in init.cpp */
  if(OpenAllegro()) /* problems initializing Allegro? */
    {
    CloseAllegro(); /* deinitialize Allegro */
    return(2);
    }

  LoadMemory(); // load/create graphics, sounds, etc.

  while(programon)
    {
    g_inGame=programon=menu.titleScreen();

    while(g_inGame)
      {
      g_inGame=inputGameFrame();

      /*if(key[KEY_F1]) // debugging, NOT a cheat code
        {
        for(int i=0;i<MAP_W;i++) // clear buildings, so worth is pure assets
          level.building[i][P1]=BLDG_NONE;
        if(plane.facing==FACING_RIGHT)
          plane.x=PLANE_BOUNDARY_RIGHT-90;
        else
          plane.x=PLANE_BOUNDARY_LEFT+90;
        }*/

      moveGameFrame();

      sound.playQueuedSounds();

      drawGameFrame(1);

      if(gamemenu.abortHack)
        {
        if(gamemenu.abortHack==ABORTHACK_1P)
          {
          player.owns[P1].cash+=SINGLE_PLAYER_MONEY_PER_ROUND;

          gamemenu.abortHack=ABORTHACK_OFF;
          level.subLevel++;
          if(level.subLevel>4 || level.currentLevel>3) // i.e. we just dusted #4
            {
            FADECOPY=create_bitmap(DB->w,DB->h);
            blit(DB,FADECOPY,0,0,0,0,SCREEN_W,SCREEN_H); // save for the fade move
            bgImage=load_jpg("data//end.jpg",palette);
            blit(bgImage,DB,0,0,0,0,SCREEN_W,SCREEN_H); // save for the fade move
            destroy_bitmap(bgImage);

            if(level.currentLevel<3)
              {
              gamemenu.textBox(300,200,SCREEN_W-600,SCREEN_H-400,makecol(200,200,200),
                               0,'z',level.currentLevel,0,0);
              }
            else
              {
              for(int i=0;i<MAP_W;i++) // clear buildings, so worth is assets only
                level.building[i][P1]=BLDG_NONE;
              gamemenu.textBox(280,190,SCREEN_W-540,SCREEN_H-380,makecol(200,200,200),
                             0,'z',3,level.goodEvilRecord>0,
                                         player.owns[P1].cash>=RICH_FINISH);
              textprintf_centre(DB, GAMEFONT, SCREEN_W>>1,SCREEN_H-44,
                    g_colorWhite, "Cash for Retirement: $%i gM",player.owns[P1].cash);
              if(player.owns[P1].cash>=RICH_FINISH)
                level.shipsUnlocked=42;
              for(int i=0;i<MAP_W;i++) // refill buildings
                  level.building[i][P1]=BLDG_DEFLECTION;
              g_inGame=0;
              }
            fadeBMP(FADECOPY);

            while(1)
              {
              poll_joystick();
              if(key[KEY_SPACE] || key[KEY_ENTER] || LMB || RMB || key[KEY_ESC] ||
                 JOY_B(0))
                {
                while(key[KEY_SPACE] || key[KEY_ENTER] || LMB || RMB || key[KEY_ESC] ||
                   JOY_B(0))
                   poll_joystick(); // wait for buttons and keys to be released
                break;
                }
              rest(2);
              }
            if(level.subLevel>4)
              {
              level.subLevel=1; // chose to skip, otherwise, we're loaded
              level.currentLevel++;
              }
            }
          if(level.subLevel==3 && g_inGame)
            {
            gamemenu.strikeOptionMode=1;
            level.loadBldg();
            if(gamemenu.abortHack==ABORTHACK_1P)
              {
              level.subLevel=1; // chose to skip, otherwise, we're loaded
              level.currentLevel++;
              if(level.currentLevel==3)
                player.addBomb(BOMB_NUKE);
              gamemenu.abortHack=ABORTHACK_OFF;
              }
            else if(gamemenu.abortHack==ABORTHACK_1P_EXTRAMISSION)
              {
              switch(level.currentLevel)
                {
                case 3:
                  player.addBomb(BOMB_BUNKERBUSTER);
                  player.addBomb(BOMB_NUKE);
                  break;
                case 2:
                  player.addBomb(BOMB_BUNKERBUSTER);
                  player.addBomb(BOMB_LASER);
                  break;
                case 1:
                  player.addBomb(BOMB_BUNKERBUSTER);
                  player.addBomb(BOMB_NAPALM);
                  break;
                }
              level.subLevel++;
              gamemenu.abortHack=ABORTHACK_OFF;
              }
            }
          if(g_inGame)
            level.loadBldg();
          }
        else if(gamemenu.abortHack==ABORTHACK_BREAKMENUS)// 2P, or just ABORTHACK_BREAKMENUS
          {
          gamemenu.abortHack=ABORTHACK_OFF;
          g_inGame=0;
          }
        else // two player results
          {
          FADECOPY=load_jpg("data//end.jpg",palette);
          blit(FADECOPY,DB,0,0,0,0,SCREEN_W,SCREEN_H); // save for the fade move

          switch(level.levelIsOver())
            {
            case P1_WIN:
              textprintf_centre(DB,GAMEFONT,SCREEN_W>>1,(SCREEN_H>>1)-20,g_colorWhite,"Player 1 Wins!");
              break;
            case P2_WIN:
              textprintf_centre(DB,GAMEFONT,SCREEN_W>>1,(SCREEN_H>>1)-20,g_colorWhite,"Player 2 Wins!");
              break;
            case DRAW_WIN:
              textprintf_centre(DB,GAMEFONT,SCREEN_W>>1,(SCREEN_H>>1)-20,g_colorWhite,"Draw Match!");
              break;
            }
          
          DB2SCREEN
          fadeBMP(FADECOPY);
          destroy_bitmap(FADECOPY);
          for(int i=0;i<15000;i++)
            {
            poll_joystick();
            if(key[KEY_SPACE] || key[KEY_ENTER] || LMB || RMB || key[KEY_ESC] ||
              JOY_B(0))
              {
              while(key[KEY_SPACE] || key[KEY_ENTER] || LMB || RMB || key[KEY_ESC] ||
                JOY_B(0))
                poll_joystick(); // wait for buttons and keys to be released
              break;
              }
            rest(1);
            }
          gamemenu.abortHack=ABORTHACK_OFF;
          g_inGame=0;
          }
        }
      }
    }

  /* CloseAllegro & EmptyMemory are mine, and are defined in init.cpp */
  EmptyMemory();   /* deinitialize Allegro */
  CloseAllegro(); /* free memory and sound bitmaps */
  }
  END_OF_MAIN(); /* This turns it into a Windows executable */

