/* INCLUDE IN SATURN.H, & INCLUDE SATURN.H IN EVERYTHING */

/* By enumerating the sounds list, we provide an easy way to (A.) destroy
   all sound data at shutdown via a for loop (and B.) associate it 1:1 with
   an integer/flag array to prevent the same sound from being generated
   multiple times on the same game frame. These details are handled in
   sound.cpp */

#define TITLE_SCREEN_SONG_DIFFICULTY_NUMBER -1 // passed to loop intro music

#define CENTERSOUND_X (SCREEN_W>>1)

enum {SFXzap,SFXcrash,SFXmajorZap,SFXmenuClick,
      SFXrocketOut,SFXelectricDeath,SFXrattleOut,SFXbadBuzzer,
      SFXnapalm,SFXdialUp,SFXengineChug,SFXwhoosh,
      SFXpurchase,SFXempty,SFXbomb,SFXengUp,SFXengDown,
      SFXswish,SFXlightning1,SFXlightning2,SFXlightning3,
      SFXlightning4,SFXplatFall,SFXplatBoom,
      SFX_NUM};

enum {SFXPARAM_VOLUME, SFXPARAM_STEREO_SPOT, SFXPARAM_NUM};

class sound_typ
  {
  public:
  SAMPLE *pSFX[SFX_NUM];
  int toPlay[SFXPARAM_NUM][SFX_NUM];
  SAMPLE *LEVEL_SONG;
  int maxVolumeSFX, maxVolumeMusic;

  sound_typ();
  void initializeSoundCard();
  void loadSfxAndMusic();
  void loopSong(char *fileName);
  void loadLevelSong(int songIndex);
  void unloadSfxAndMusic();
  void queueSound(int SFXindex,int SFXvolume,float SFXspot_x);
  void playSound(int SFXindex,int SFXvolume,float SFXspot_x);
  void playQueuedSounds();
  };

extern sound_typ sound;

