#include "saturn.h"

viewport_typ viewport;

/* The actual class prototype is defined inside init.h */
  viewport_typ::viewport_typ()
    {
    reset();
    }

  void viewport_typ::reset()
    {
    lastxv=0;
    lastyv=0;
    x=0;
    y=0;
    shakeMagnitude=0;
    boundaryRight=3*SCREEN_W;
    boundaryBottom=2*SCREEN_H;
    }

  void viewport_typ::shakeScreen(int amt)
    {
    shakeMagnitude+=amt;
    }

  void viewport_typ::moveViewport()
    {
    lastxv=x;
    lastyv=y;
    x=(int)(plane.x+SPEED_LAG_ON_CAMERA*plane.xv)-(SCREEN_W>>1);
    y=(int)(plane.y+(SPEED_LAG_ON_CAMERA*plane.yv/2.0))-(SCREEN_H>>2)-(SCREEN_H>>3);
    lastxv=x-lastxv;
    lastyv=y-lastyv;

    if(shakeMagnitude>0)
      {
      x+=rand()%shakeMagnitude;
      x-=rand()%shakeMagnitude;
      y+=rand()%shakeMagnitude;
      y-=rand()%shakeMagnitude;
      shakeMagnitude-=3; // rapid decay of shaking
	    if(shakeMagnitude<0)
	  	  shakeMagnitude=0;
      }

    if(x<0)
      x=0;
    if(x+SCREEN_W>boundaryRight)
      x=boundaryRight-SCREEN_W;
    if(y<0)
      y=0;
    if(y+SCREEN_H>boundaryBottom)
      y=boundaryBottom-SCREEN_H;
    }

  void viewport_typ::drawViewport()
    {
    blit(DB,screen,0,0,0,0,SCREEN_W,SCREEN_H);
    }

