#include "saturn.h"

weather_typ weather;

/* The actual class prototype is defined inside init.h */
  weather_typ::weather_typ()
    {
    reset();
    }

  void weather_typ::reset()
    {
    windSpeedBase=windSpeedMaxDev=0.0;
    windSpeedRateOfDev=turbSpeedBase=0.0;
    turbSpeedMaxDev=turbSpeedRateOfDev=0.0;
    windNow=turbNow=0.0;
    turbAng=0.0;
    lightningStrike=0;
    nukeRain=0;
    if(SCREEN_W!=0 && SCREEN_H!=0)
      randomizeRain();
    else
      for(int i=0;i<RAIN_NUM;i++)
        {
        rain[i].x=rand()%1024;
        rain[i].y=rand()%768;
        }
    }

  void weather_typ::randomizeRain()
    {
    for(int i=0;i<RAIN_NUM;i++)
      {
      rain[i].x=(rand()%SCREEN_W);
      rain[i].y=(rand()%SCREEN_H);
      }
    }

  void weather_typ::loadGraphics()
    {
    }

  void weather_typ::unloadGraphics()
    {
    }

  void weather_typ::moveWeather()
    {
    int i_windNow=int(windNow)-viewport.lastxv;
    int i_turbNow=int(turbNow)-viewport.lastyv;

    for(int i=0;i<RAIN_NUM;i++)
      {
      rain[i].x+=i_windNow;
      if(rand()&1)
        rain[i].x++;
      else
        rain[i].x++;
      if(rain[i].x>SCREEN_W)
        rain[i].x-=SCREEN_W;
      if(rain[i].x<0)
        rain[i].x+=SCREEN_W;

      rain[i].y+=RAINFALL_SPEED+i_turbNow;
      if(rand()&1)
        rain[i].y++;
      else
        rain[i].y++;
      if(rain[i].y<0)
        rain[i].y+=SCREEN_H;
      if(rain[i].y>SCREEN_H)
        rain[i].y-=SCREEN_H;
      }

    if(rand()&1) windNow+=windSpeedRateOfDev;
    else windNow-=windSpeedRateOfDev;
    turbAng-=(rand()%16);
    windNow=(windNow+windSpeedBase*cos(turbAng))/2.0;
    if(windNow<windSpeedBase-windSpeedMaxDev)
      windNow=windSpeedBase-windSpeedMaxDev;
    if(windNow>windSpeedBase+windSpeedMaxDev)
      windNow=windSpeedBase+windSpeedMaxDev;

    if(rand()&1) turbNow+=turbSpeedRateOfDev;
    else turbNow-=turbSpeedRateOfDev;
    turbAng+=6+(rand()%32);
    turbNow=(turbNow+turbSpeedBase*sin(turbAng))/2.0;
    if(turbNow<turbSpeedBase-turbSpeedMaxDev)
      turbNow=turbSpeedBase-turbSpeedMaxDev;
    if(turbNow>turbSpeedBase+turbSpeedMaxDev)
      turbNow=turbSpeedBase+turbSpeedMaxDev;

    //int i_windNow=int(windNow*5.0);
    //int i_turbNow=int(turbNow*5.0);

    if(rand()%800==1)
      {
      lightningStrike=1;
      sound.queueSound(SFXlightning1,255,rand()%SCREEN_W);
      }
    if(rand()%1000==1)
      {
      lightningStrike=1;
      sound.queueSound(SFXlightning2,255,rand()%SCREEN_W);
      }
    if(rand()%1200==1)
      {
      lightningStrike=1;
      sound.queueSound(SFXlightning3,255,rand()%SCREEN_W);
      }
    if(rand()%600==1)
      {
      lightningStrike=1;
      sound.queueSound(SFXlightning4,255,rand()%SCREEN_W);
      }
    }

  void weather_typ::drawWeather()
    {
    int i_windNow=int(windNow*4);
    int i_turbNow=int(turbNow*4);
    int rainColor[10];

    if(!nukeRain)
      {
      for(int i=0;i<10;i++)
        rainColor[i]=makecol(80+(rand()%80),80+(rand()%80),rand()%40);
      }
    else
      {
      for(int i=0;i<10;i++)
        {
        rainColor[i]=200+(rand()%55);
        rainColor[i]=makecol(rainColor[i],rainColor[i],rainColor[i]);
        }
      nukeRain=0;
      }

    if(!lightningStrike)
      {
      for(int i=0;i<RAIN_NUM;i++)
        line(DB,rain[i].x,rain[i].y,rain[i].x+i_windNow,
                       rain[i].y+RAINFALL_SPEED+i_turbNow,rainColor[rand()%10]);
      }
    else
      {
      rectfill(DB,0,0,SCREEN_W,SCREEN_H,g_colorWhite);
      viewport.shakeScreen(7+(rand()%20));
      lightningStrike=0;
      vsync();
      DB2SCREEN
      rest(20);
      }
    }

